/*==========================================================================
*
*  Example_1 - demo application
*  by Branislav Lehotsky
*  Demonstration of using BonbliotFramework (c)
*  - is showing one Dialog with basic elements on it (DUI, DUIR, Slider, ScrollBar, Switch, Button)
*
*  Example_1 - demontran apka
*  Branislav Lehotsk
*  Demontruje pouitie BonbliotFramework (c)
*  - zobraz sa jedno dialgov okno (Dialog) so zkladnmi elementami (DUI, DUIR, Slider, ScrollBar, Switch, Button)
*
*==========================================================================
*/
#include <ddraw.h>     //Direct Draw 
#include <mmsystem.h>  //koli LPWAVEFORMATEX v <dsound.h> a.i.
#include <dsound.h>    //Direct Sound

//---------------------- //hlavicka hlavnej kniznice, FrameWork by Bonbliot (c)
#include "DBonbliotFW.h"    
//----------------------

#define IDC_BTN_DLG_SH     100

#define IDC_BTN_OK         200
#define IDC_BTN_CANCEL     201
#define IDI_BTN_OK         202 
#define IDI_BTN_CANCEL     203

#define IDC_RADIO_1        204
#define IDC_RADIO_2        205
#define IDC_RADIO_3        206

#define IDC_DUI            207
#define IDC_DUIR           208

#define IDC_SCROLLBAR      209
#define IDC_SLIDER         210

#define IDC_RADIO1         211
#define IDC_RADIO2         212
#define IDC_RADIO3         213

#define IDC_CHB1           214
#define IDC_CHB2           215
#define IDC_CHB3           216

#define IDC_RADIO_FONT1    217
#define IDC_RADIO_FONT2    218
#define IDC_RADIO_FONT3    219

#define IDC_BTN_1          221
#define IDC_BTN_2          222
#define IDC_BTN_3          223
#define IDC_BTN_4          224
#define IDC_BTN_5          225

bool pravedole;

bf_CDas_Surface  emoticons_srf;
bf_CDas_Surface  imgres_srf;

//------------------------------------------------------
// Demonstracny dialog
//------------------------------------------------------
class CMyDemoDlg : public bf_CDialog
{
public:
  bf_CLabel *m_title;

  //bf_CEDB  *m_edb;

  bf_CDUIR *m_duiR;
  bf_CDUI  *m_dui;

  bf_CScrollBar *m_SB;
  bf_CSlider *m_sld;

  bf_CLabel *lab_sld;
  bf_CLabel *lab_SB;
  
  bf_CSwitch *rb_1;
  bf_CSwitch *rb_2;
  bf_CSwitch *rb_3;

  bf_CSwitch *chb_1;
  bf_CSwitch *chb_2;
  bf_CSwitch *chb_3;

  bf_CSwitch *rb_font1;
  bf_CSwitch *rb_font2;
  bf_CSwitch *rb_font3;

  bf_CDecor *dcH, *dc1, *dc2, *dc3;

  bf_CButton *btn_1, *btn_2, *btn_3, *btn_4, *btn_5;

  CMyDemoDlg(bf_CPosCHLO *parent, int iID);
  ~CMyDemoDlg();
  virtual int SetupVisual();
  virtual bool HandleFWInteraction(int iID, int ivalue, bf_CPos *p_pol = NULL);
  void Insert_DUI_DUIR();
};

//----------------------------------------------------------------
// App
//----------------------------------------------------------------
class CMyApp : public bf_CAppScreen
{
public:
  CMyDemoDlg * m_DemoDLG;

  bf_CButton * m_btn_SH;
  bf_CLabel * m_label_1;
   
  CMyApp(HINSTANCE hInstance, int nCmdShow, char* cLocApp_INI);
  //~CMyApp();
  virtual void Do_LOAD_SRF();
  virtual void Do_RELEASE_SRF();
  virtual void Do_RESTORE_SRF();
  //virtual void Init();
  virtual int SetupVisual();
  //virtual void Init2();
  virtual void HandleWMInteraction(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
  virtual bool HandleFWInteraction(int iID, int ivalue, bf_CPos *p_pol = NULL);
  virtual void ChangedResolution(int maxx_old, int maxy_old, int maxx_new, int maxy_new);
  virtual void Redraw_Screen(LPDIRECTDRAWSURFACE p_lpDDS);
};

//=== DLG ==================================================================================================================

//-----------------------------------------------
// Konstruktor
//-----------------------------------------------
CMyDemoDlg::CMyDemoDlg(bf_CPosCHLO *parent, int iID) : bf_CDialog(parent, iID)
{
  m_title = new bf_CLabel(this, 4, 0, (char*)"Void title");  //tu este nemusim poznat jazyk
   
  m_dui = new bf_CDUI(this, IDC_DUI /*20, 20*/);
  m_dui->autohide = false;
  
  m_duiR = new bf_CDUIR(this, IDC_DUIR /*120, 20*/);
  m_duiR->autohide = false;
  m_duiR->Rol_poc_zobr = 4;    //kolko viditelnych volieb bez rolovania

  m_SB  = new bf_CScrollBar(this, IDC_SCROLLBAR );

  dcH = new bf_CDecor(this);
  m_sld = new bf_CSlider(this, IDC_SLIDER );

  //m_edb = new bf_CEDB(this, 26, 31);
  //m_edb->sir = 100; m_edb->vys = 22; m_edb->EDITTEXT_max = 15;

  rb_1 = new bf_CSwitch(this, IDC_RADIO1);
  rb_2 = new bf_CSwitch(this, IDC_RADIO2);
  rb_3 = new bf_CSwitch(this, IDC_RADIO3);

  chb_1 = new bf_CSwitch(this, IDC_CHB1);
  chb_2 = new bf_CSwitch(this, IDC_CHB2);
  chb_3 = new bf_CSwitch(this, IDC_CHB3);

  rb_font1 = new bf_CSwitch(this, IDC_RADIO_FONT1);
  rb_font2 = new bf_CSwitch(this, IDC_RADIO_FONT2);
  rb_font3 = new bf_CSwitch(this, IDC_RADIO_FONT3);

  dc1 = new bf_CDecor(this);
  dc2 = new bf_CDecor(this);
  dc3 = new bf_CDecor(this);

  btn_1 = new bf_CButton(this, IDC_BTN_1);
  btn_2 = new bf_CButton(this, IDC_BTN_2);
  btn_3 = new bf_CButton(this, IDC_BTN_3);
  btn_4 = new bf_CButton(this, IDC_BTN_4);
  btn_5 = new bf_CButton(this, IDC_BTN_5);

  new bf_CButton(this, IDC_BTN_OK);
  new bf_CButton(this, IDC_BTN_CANCEL);
  //new bf_CLabel(this, IDL_DLG_OK, (char*)"OK");
  //new bf_CLabel(this, IDL_DLG_ZRUS, (char*)"Cancel");  //toto sa ale este moze zmenit v setupvisual
  new bf_CPosIcon(this, IDI_BTN_OK);
  new bf_CPosIcon(this, IDI_BTN_CANCEL);

  //anonymne labely
  new bf_CLabel(this, 15, 23, (char*)"DUIR");
  new bf_CLabel(this, 225, 23, (char*)"DUI");
  new bf_CLabel(this, 405, 23, (char*)"Switches");
  new bf_CLabel(this, 15, 323, (char*)"Slider2");
  new bf_CLabel(this, 15, 362, (char*)"ScrollBar");
  new bf_CLabel(this, 405, 226, (char*)"Buttons");

  lab_sld = new bf_CLabel(this, 165, 323, (char*)"");
  lab_SB = new bf_CLabel(this, 165, 362, (char*)"");
};

//----------------------------------------------------------------
// destruktor
//----------------------------------------------------------------
CMyDemoDlg::~CMyDemoDlg()
{/*
  delete m_title;

  delete m_dui;
  delete m_duiR;

  delete m_SB;

  delete dcH;
  delete m_sld;

  //delete m_edb;

  delete rb_1;
  delete rb_2;
  delete rb_3;

  delete chb_1;
  delete chb_2;
  delete chb_3;

  delete rb_font1;
  delete rb_font2;
  delete rb_font3;

  delete dc1;
  delete dc2;
  delete dc3;

  delete btn_1;
  delete btn_2;
  delete btn_3;
  */
};

//-----------------------------------------------
// Nastavi dizajn, vizual dialogu
//-----------------------------------------------
int CMyDemoDlg::SetupVisual()
{
  if (bf_Get_Lang() == bf_c_Lang_SK)
    m_title->Dsgn(4, 0, (char*)"Demo - Dialg");
  else //if ( bf_Get_Lang() == bf_c_Lang_EN )
    m_title->Dsgn(4, 0, (char*)"Demo - Dialog");

  Insert_DUI_DUIR();
  m_duiR->RESET_DEFAULT();
  m_dui->RESET_DEFAULT();
  m_duiR->Dsgn(15, 40);   //t.j. MoveToRel(5,20)
  m_dui->Dsgn(225, 40);

  dcH->Dsgn(15, 343, 310, 0);
  m_sld->Dsgn(2, 'H',337, 15, 310);
  m_sld->SR(0, 100);

  m_SB->Dsgn_Stock('H', 15,380, 310);
  m_SB->SR(0, 20);

  int xx = 413; int yy = 53; int dy = 24;
  rb_1->Dsgn(1, xx, yy);  yy += dy;
  rb_1->Dsgn_label(20, -1, (char*)"radio 1", RGB(0,0,0));
  rb_2->Dsgn(1, xx, yy);  yy += dy;
  rb_2->Dsgn_label(20, -1, (char*)"radio 2", RGB(0, 0, 0));
  rb_3->Dsgn(1, xx, yy);  yy += dy;
  rb_3->Dsgn_label(20, -1, (char*)"radio 3", RGB(0, 0, 0));
  yy = 141;
  int group = 1;
  chb_1->Dsgn(0, xx, yy, group);  yy += dy;
  chb_1->Dsgn_label(20, -1, (char*)"check 1", RGB(0, 0, 0));
  chb_2->Dsgn(0, xx, yy, group);  yy += dy;
  chb_2->Dsgn_label(20, -1, (char*)"check 2", RGB(0, 0, 0));
  chb_3->Dsgn(0, xx, yy, group);  yy += dy;
  chb_3->Dsgn_label(20, -1, (char*)"check 3", RGB(0, 0, 0));
  xx = 357;
  yy = 385;
  group = 2;
  rb_font1->Dsgn(1, xx, yy, group);  xx += 80;
  rb_font1->Dsgn_label(20, -1, (char*)"font 1", RGB(0, 0, 0));
  rb_font2->Dsgn(1, xx, yy, group);  xx += 80;
  rb_font2->Dsgn_label(20, -1, (char*)"font 2", RGB(0, 0, 0));
  rb_font3->Dsgn(1, xx, yy, group);  xx += 80;
  rb_font3->Dsgn_label(20, -1, (char*)"font 3", RGB(0, 0, 0));

  dc1->Dsgn(405, 42,  101, 82);
  dc2->Dsgn(405, 132, 101, 82);
  dc3->Dsgn(349, 378, 263, 30);

  btn_1->Dsgn0_VoidDC(405, 245, 95, 27);
  btn_1->Das_Surface = &imgres_srf;
  btn_1->REGISTER(20,20); btn_1->REGISTER(70, 20); btn_1->REGISTER(120, 20);

  btn_2->Dsgn0_VoidDC(456, 250, 95, 27);
  btn_2->Das_Surface = &imgres_srf;
  btn_2->REGISTER(160, 20); btn_2->REGISTER(190, 20); btn_2->REGISTER(230, 20);

  btn_3->Dsgn2_UserA(494, 249, &imgres_srf, 20,70, 55,70, 90,70 );
  btn_4->Dsgn2_UserA(533, 249, &imgres_srf, 130,70, 170,70, 205,70);

  btn_5->Dsgn0_VoidDC(573, 251, 37, 30);

  ((bf_CButton*)FindCHLWithID(IDC_BTN_OK))->Dsgn0_VoidDC(516, 42, 95, 27);
  ((bf_CButton*)FindCHLWithID(IDC_BTN_OK))->Dsgn_label(30, 5, (char*)"OK", RGB(0, 0, 0) );
  ((bf_CPosIcon*)FindCHLWithID(IDI_BTN_OK))->Dsgn_PolIcon_Copy(516 + 5, 42 + 5, bf_Get_Ref_DSGN_Struct()->_ok_icon_);
  
  ((bf_CButton*)FindCHLWithID(IDC_BTN_CANCEL))->Dsgn0_VoidDC(516, 77, 95, 27);
  if (bf_Get_Lang() == bf_c_Lang_SK)
    ((bf_CButton*)FindCHLWithID(IDC_BTN_CANCEL))->Dsgn_label(25, 5, (char*)"Zrui", RGB(0, 0, 0));
  else //if ( bf_Get_Lang() == bf_c_Lang_EN )
    ((bf_CButton*)FindCHLWithID(IDC_BTN_CANCEL))->Dsgn_label(25, 5, (char*)"Cancel", RGB(0, 0, 0));
  ((bf_CPosIcon*)FindCHLWithID(IDI_BTN_CANCEL))->Dsgn_PolIcon_Copy(516 + 5, 77 + 5, bf_Get_Ref_DSGN_Struct()->_cancel_icon_);

  return 0;  //vsetko ok
}

//-----------------------------------------------
// Spracuje interakciu
//-----------------------------------------------
bool CMyDemoDlg::HandleFWInteraction(int iID, int ivalue, bf_CPos *p_pol /*= NULL*/)
{
  //bf_LOG1( "bf_CAppRozlisDlg::HandleFWInteraction, ID", iID );  //<<<<<<< DEBUG

  switch (iID)
  {
   case IDC_BTN_OK:
   case IDC_BTN_CANCEL:
     visible = false;
     break;

   case IDC_RADIO_FONT1:
     bf_DSGN_SetLabelsDefaultFont(15, 9, FW_NORMAL, "Verdana");  //vseobecne font pre lable
     break;
   case IDC_RADIO_FONT2:
     bf_DSGN_SetLabelsDefaultFont(15, 8, FW_NORMAL, "Verdana");
     break;
   case IDC_RADIO_FONT3:
     bf_DSGN_SetLabelsDefaultFont(15, 8, FW_BOLD, "Verdana");
     break;

   case IDC_SLIDER:
     lab_sld->SetNumber( m_sld->GP() );
     break;

   case IDC_SCROLLBAR:
     lab_SB->SetNumber( m_SB->GP() );
     break;
  }

  if (PARENT != NULL)
    return ((bf_CPosCHLO*)PARENT)->HandleFWInteraction(iID, ivalue, p_pol);  //posli to dalej ( hore na rodicovsky PolCHLO )

  //bf_CDialog::HandleFWInteraction( iID, ivalue, p_pol );  //obsluzit class predka ?
  return false;  //sme uplne hore v danom strome (resp. podstrome)
}

//-----------------------------------------------
void CMyDemoDlg::Insert_DUI_DUIR()
{
  m_dui->ADD(1, (char*) "Emoticon 1", new bf_CIcon(&emoticons_srf, 30, 30), true);
  m_dui->ADD(2, (char*) "Emoticon 2", new bf_CIcon(&emoticons_srf, 100, 30), true);
  m_dui->ADD(3, (char*) "Emoticon 3", new bf_CIcon(&emoticons_srf, 170, 30), true);
  m_dui->ADD(4, (char*) "Emoticon 4", new bf_CIcon(&emoticons_srf, 240, 30), true);

  m_duiR->ADD(1, (char*) "Emoticon 1", new bf_CIcon(&emoticons_srf, 30, 30), true);
  m_duiR->ADD(2, (char*) "Emoticon 2", new bf_CIcon(&emoticons_srf, 100, 30), true);
  m_duiR->ADD(3, (char*) "Emoticon 3", new bf_CIcon(&emoticons_srf, 170, 30), true);
  m_duiR->ADD(4, (char*) "Emoticon 4", new bf_CIcon(&emoticons_srf, 240, 30), true);
  m_duiR->ADD(5, (char*) "Emoticon 5", new bf_CIcon(&emoticons_srf, 30, 100), true);
  m_duiR->ADD(6, (char*) "Emoticon 6", new bf_CIcon(&emoticons_srf, 100, 100), true);
  m_duiR->ADD(7, (char*) "Emoticon 7", new bf_CIcon(&emoticons_srf, 170, 100), true);
  m_duiR->ADD(8, (char*) "Emoticon 8", new bf_CIcon(&emoticons_srf, 240, 100), true);
  m_duiR->ADD(9, (char*) "Emoticon 9", new bf_CIcon(&emoticons_srf, 30, 160), true);
  m_duiR->ADD(10, (char*) "Emoticon 10", new bf_CIcon(&emoticons_srf, 100, 160), true);
  /*
  m_duiR->ADD(11, (char*) "Emoticon 11", new bf_CIcon(&emoticons_srf, 170, 160), true);
  m_duiR->ADD(12, (char*) "Emoticon 12", new bf_CIcon(&emoticons_srf, 240, 160), true);
  m_duiR->ADD(13, (char*) "Emoticon 13", new bf_CIcon(&emoticons_srf, 30, 220), true);
  m_duiR->ADD(14, (char*) "Emoticon 14", new bf_CIcon(&emoticons_srf, 100, 220), true);
  m_duiR->ADD(15, (char*) "Emoticon 15", new bf_CIcon(&emoticons_srf, 170, 220), true);
  m_duiR->ADD(16, (char*) "Emoticon 16", new bf_CIcon(&emoticons_srf, 240, 220), true);
  */
}

//=== APP ==================================================================================================================

//----------------------------------------------------------------
// Konstruktor
//----------------------------------------------------------------
CMyApp::CMyApp(HINSTANCE hInstance, int nCmdShow, char* cLocApp_INI) : bf_CAppScreen(hInstance, nCmdShow, cLocApp_INI)
{
   m_DemoDLG = new CMyDemoDlg(this, -1);

   m_label_1 = new bf_CLabel(this, -1);
   m_btn_SH = new bf_CButton(this, IDC_BTN_DLG_SH);
};

//----------------------------------------------------------------
// destruktor
//----------------------------------------------------------------
//CMyApp::~CMyApp()
//{
//};

//----------------------------------------------------------------
// nahratie SRF
//----------------------------------------------------------------
void CMyApp::Do_LOAD_SRF()
{
  emoticons_srf.LOAD_SURFACE((char*) "emoticons.bmp");
  emoticons_srf.BC_SET(0, 0);
  emoticons_srf.TC_SET(3, 3);
  imgres_srf.LOAD_SURFACE((char*) "imgres.bmp"); 
  imgres_srf.BC_SET(0, 0);
  imgres_srf.TC_SET(3, 3);
};

//----------------------------------------------------------------
// Uvolnit vsetky objekty surfaces
//----------------------------------------------------------------
void CMyApp::Do_RELEASE_SRF()
{
  emoticons_srf.RELEASE_SURFACE();
  imgres_srf.RELEASE_SURFACE();
}

//----------------------------------------------------------------
// Restore objektov surfaces
//----------------------------------------------------------------
void CMyApp::Do_RESTORE_SRF()
{
  emoticons_srf.RESTORE_SURFACE();
  imgres_srf.RESTORE_SURFACE();
}


//----------------------------------------------------------------
// Nastavi vizual, dizajn dialogu
//----------------------------------------------------------------
int CMyApp::SetupVisual()
{
  bf_CAppScreen::SetupVisual(); //obsluzit najprv predka (od koho je App odvodena)

  m_DemoDLG->Dsgn(10, 10, 626, 420, 2);
  m_DemoDLG->GO_TO_CENTER(bf_Get_SX(), bf_Get_SY());
  
  m_label_1->Dsgn(200, 100, (char*)"Dialog demo");
  m_label_1->CR_text_color = RGB(100, 180, 100);
  m_label_1->font_hnd = bf_DSGN_CreateFont(75, 40, FW_NORMAL, "Verdana");
  m_label_1->GO_TO_CENTER(bf_Get_SX(), 100);

  m_btn_SH->Dsgn0_VoidDC(885, 672,   106, 45);   //default: void_SIR = 100; void_VYS = 45;
  m_btn_SH->Dsgn_label(5, 15, (char*)"Show/Hide", RGB(100, 180, 100));
  m_btn_SH->GO_TO_CENTER(bf_Get_SX(), bf_Get_MAXY() - 60);

  return 0;
}

//----------------------------------------------------------------
// Spracovanie WM 
//----------------------------------------------------------------
void CMyApp::HandleWMInteraction(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  int mx,my;
  switch (message)
  {
  case WM_RBUTTONDOWN:      //pravy klik mysou DOWN
    mx = LOWORD(lParam);
    my = HIWORD(lParam);
    m_DemoDLG->GO_TO_CENTER(mx, my);
    pravedole = true;
    break;

  case WM_RBUTTONUP:      //pravy klik mysou UP
    pravedole = false;
    break;

  case WM_MOUSEMOVE:
    if ( pravedole )
    {
      mx = LOWORD(lParam);
      my = HIWORD(lParam);
      m_DemoDLG->GO_TO_CENTER(mx, my);
    }
    break;
  }
}

//----------------------------------------------------------------
// Da priestor na akciu 
//----------------------------------------------------------------
bool CMyApp::HandleFWInteraction(int iID, int ivalue, bf_CPos *p_pol)
{
  //postup cez dimenziu predkov
  bool l_b = bf_CAppScreen::HandleFWInteraction(iID, ivalue, p_pol);  //obsluzit class predka

  switch (iID)
  {
  case IDC_BTN_DLG_SH:
    m_DemoDLG->visible = !m_DemoDLG->visible;
    break;
  }

  return l_b;
}

//----------------------------------------------------------------
// Volane po zmene rozmerov obrazovky
//----------------------------------------------------------------
void CMyApp::ChangedResolution(int maxx_old, int maxy_old, int maxx_new, int maxy_new)
{
  //postup cez dimenziu predkov (vratit funkcnost predkovi, lebo cez virtual bola obidena, prepisana)
  bf_CAppScreen::ChangedResolution(maxx_old, maxy_old, maxx_new, maxy_new);  //obsluzit class predka

  m_btn_SH->GO_TO_CENTER(bf_Get_SX(), bf_Get_MAXY() - 60);
  m_label_1->GO_TO_CENTER(bf_Get_SX(), 100);
  m_DemoDLG->GO_TO_CENTER(bf_Get_SX(), bf_Get_SY());
}

//----------------------------------------------------------------
// Prekreslit celu scenu 
//----------------------------------------------------------------
void CMyApp::Redraw_Screen(LPDIRECTDRAWSURFACE p_lpDDS)
{
  //<--- vymazat
  //DDSURFACE_ZMAZ(p_lpDDS, 500);
  //emoticons_srf.DRAW(5, 5);
}

//==============================================================================

//----------------------------------------------------------------
// Vstupny bod pre Appku
//----------------------------------------------------------------
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
  LPSTR lpCmdLine, int nCmdShow)
{
  CMyApp *pAPP = new CMyApp(hInstance, nCmdShow, (char*) "EXAMPLE.INI");    //vytvorit instanciu
  pAPP->SetBackground(500, (char*)"", false);   //tmavomodra farba pozadia, ziaden obraz ako podklad, ziadne logo
  pAPP->SetAppInfo((char*)"Example, Dialog demo", (char*)"(version: 1.0)", (char*)"Branislav Lehotsk");  //info polia
  pAPP->SetLang( bf_c_Lang_EN );   // bf_c_Lang_EN / bf_c_Lang_SK 
  pAPP->Execute();  //spustit
  delete pAPP;
  return 0;
}
